import { EventEmitter, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { Observable } from 'rxjs';
import { ComboboxItem, ComboboxOptionContext } from '../combobox.interface';
import { BbComboboxLabel } from '../combobox-label.directive';
import * as i0 from "@angular/core";
export declare class BbCombobox<T = unknown> implements OnInit, OnDestroy {
    labelComponent?: TemplateRef<BbComboboxLabel>;
    optionTemplate?: TemplateRef<ComboboxOptionContext>;
    value: T | null;
    bindLabel: string | null;
    bindValue: string | null;
    disabled: boolean;
    set data(items: T[] | Observable<T[]>);
    get data(): T[] | Observable<T[]>;
    valueChange: EventEmitter<T>;
    items$: Observable<ComboboxItem<T>[]>;
    onChange: (newValue: T) => void;
    onTouched: () => void;
    private _cache$;
    private _dataSubscription;
    ngOnInit(): void;
    ngOnDestroy(): void;
    registerOnChange(fn: (newValue: T) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    writeValue(newValue: T): void;
    select(value: T): void;
    private setItems;
    private createComboboxItem;
    private setCache;
    private handleData;
    private handleDataObservable;
    private emitChangeEvent;
    static ɵfac: i0.ɵɵFactoryDeclaration<BbCombobox<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BbCombobox<any>, "bb-combobox", never, { "value": { "alias": "value"; "required": false; }; "bindLabel": { "alias": "bindLabel"; "required": false; }; "bindValue": { "alias": "bindValue"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "data": { "alias": "data"; "required": false; }; }, { "valueChange": "valueChange"; }, ["labelComponent", "optionTemplate"], never, true, never>;
    static ngAcceptInputType_disabled: unknown;
}
