import { ActivatedRouteSnapshot, Router, RouterStateSnapshot, UrlTree } from '@angular/router';
import { InjectionToken, Provider } from '@angular/core';
export declare class PermissionsConfig {
    provider?: Provider;
    localPermissions?: LocalPermissionsData;
    onPermissionDenied?: (router: Router, snapshot: ActivatedRouteSnapshot, state: RouterStateSnapshot) => UrlTree;
}
export interface PermissionsOptions {
    mode?: PermissionsMode;
}
export type PermissionsMode = 'and' | 'or' | 'not';
export type LocalPermissionsData<T extends string = any> = Record<string, T[] | '*'>;
export declare const PERMISSIONS_CONFIG: InjectionToken<PermissionsConfig>;
