import { OnDestroy, OnInit, QueryList, TemplateRef } from '@angular/core';
import { DataSourcePageResponse } from '../../interfaces/datasource.interface';
import { FormControl, FormGroup } from '@angular/forms';
import { DataSource, DataSourceRequest } from '../../data/datasource.data';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare class BbTableColumnDef {
    static ɵfac: i0.ɵɵFactoryDeclaration<BbTableColumnDef, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BbTableColumnDef, "[bbTableColumnDef]", never, {}, {}, never, never, true, never>;
}
export declare class BbTableRowDef {
    static ɵfac: i0.ɵɵFactoryDeclaration<BbTableRowDef, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BbTableRowDef, "[bbTableRowDef]", never, {}, {}, never, never, true, never>;
}
export declare class BbTable implements OnInit, OnDestroy {
    tableColumnTemplates: QueryList<TemplateRef<any>>;
    tableRowTemplate?: TemplateRef<any>;
    identifier: string | null;
    dataSource: DataSource;
    queryFields: string[];
    sortingStrategy: 'single' | 'multiple';
    header: TemplateRef<any> | boolean;
    footer: TemplateRef<any> | boolean;
    private _sizes;
    get sizes(): number[];
    set sizes(newValue: number[]);
    request: DataSourceRequest;
    data$: Observable<{
        state: string;
        statusCode?: number;
        result?: DataSourcePageResponse;
    }>;
    isLoading$: Observable<boolean>;
    form: FormGroup;
    queryControl: FormControl<string>;
    private _headerCount;
    private _subscription;
    ngOnInit(): void;
    ngOnDestroy(): void;
    get headerCount(): number;
    get sortControl(): FormGroup<any>;
    get pageNumberControl(): FormControl<number>;
    get pageSizeControl(): FormControl<number>;
    refresh(): void;
    setHeaderCount(amount: -1 | 1): void;
    private updateSizes;
    private composeForm;
    private watchDataChanges;
    private subscribeToChanges;
    private getQueryChanges;
    private getFormChanges;
    static ɵfac: i0.ɵɵFactoryDeclaration<BbTable, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BbTable, "bb-table", never, { "identifier": { "alias": "identifier"; "required": false; }; "dataSource": { "alias": "dataSource"; "required": false; }; "queryFields": { "alias": "queryFields"; "required": false; }; "sortingStrategy": { "alias": "sortingStrategy"; "required": false; }; "header": { "alias": "header"; "required": false; }; "footer": { "alias": "footer"; "required": false; }; "sizes": { "alias": "sizes"; "required": false; }; }, {}, ["tableRowTemplate", "tableColumnTemplates"], ["bb-table-header-cell", "*"], true, never>;
}
