import { DataSourcePageRequest, DataSourcePageResponse } from '../interfaces/datasource.interface';
import { Observable } from 'rxjs';
export declare class DataSourceRequest {
    private _request$;
    private _loading$;
    get loading(): Observable<boolean>;
    get when(): Observable<DataSourcePageRequest>;
    startLoading(): void;
    stopLoading(): void;
    update(params?: Partial<DataSourcePageRequest>): void;
}
export declare abstract class DataSource<T = any> {
    abstract handle(request: DataSourceRequest): Observable<DataSourcePageResponse<T>>;
}
